/**
* @file
*/

// example function
// (function ($, Drupal) {
// Drupal.AjaxCommands.prototype.fetch = function (ajax, response, status) {
//   console.log(response.message);
// }

// })(jQuery, Drupal);




Drupal.behaviors.example_hello = {
  attach: (function ($, context, settings) {

    // Attach a click listener to the edit button.
    var clearBtn = document.getElementById('edit-button');
    var doiResponse;
    clearBtn.addEventListener('click', function () {

      // Do something!
      doi = $("#edit-doitext").val();
      typeMap = {
        "article-journal": "Journal Article",
        "book": "Book",
        "paper-conference": "Conference Proceedings",
        "article-magazine": "Magazine Article",
        "report": "Technical Report",
        "article-newspaper": "Newspaper Article"
      }
      $.ajax({
        url: "https://dx.doi.org/" + doi, dataType: "json",
        success: function (response) {
          doiResponse = response;
          window.doiResponse = doiResponse;
          entities = {
            "title": $("#edit-title-0-value").val(response.title),
            "container-title": $("#edit-field-ercore-pb-journal-name-0-value").val(response["container-title"]),
            "volume": $("#edit-field-ercore-pb-journal-volume-0-value").val(response.volume),
            "publisher": $("#edit-field-ercore-pb-publisher-0-value").val(response.publisher),
            "page": $("#edit-field-ercore-pb-journal-pages-0-value").val(response.page),
            "DOI": $("#edit-field-ercore-pb-doi-0-value").val(response["DOI"]),
            "type": $("#edit-field-ercore-pb-type").val(typeMap[response.type]),
            // "abstract" : $("edit-body-0-value").val(response.abstract),//TODO
          }
          // console.log(entities);
          $.each(entities, function (index, value) {
            if (response.hasOwnProperty(index) == true) {
              // console.log(value);
              value;
            }

          });
          console.log(response);
          $("#edit-field-ercore-pb-status").val("0");
          $("#edit-field-ercore-pb-date-wrapper").show();
          $("#edit-field-ercore-pb-submit-date-wrapper").show();
          $("#edit-field-ercore-nsf-wrapper").show();
          $("#edit-field-ercore-pb-journal-name-wrapper").show();
          $("#edit-field-ercore-pb-journal-volume-wrapper").show();
          $("#edit-field-ercore-pb-publisher-wrapper").show();
          $("#edit-field-ercore-pb-coll-title-wrapper").show();
          $("#edit-field-ercore-pb-journal-pages-wrapper").show();
          $("#edit-field-ercore-pb-doi-wrapper").show();
          $("#edit-field-ercore-pb-issn-wrapper").show();
          $("#edit-field-ercore-pb-ark-wrapper").show();
          $("#edit-body-wrapper").show();
          // $("#edit-body-0-value").show();

          // //Authors List
          // author_list = ""
          // citation_author_list = ""
          // $.each(response.author, function (index, this_author) {
          //   author_list = author_list + this_author['given'] + " " + this_author['family'] + "\n"

          //   if (this_author['sequence'] == "first") {
          //     citation_author_list = citation_author_list + this_author['family'] + ", " + this_author['given']
          //   } else {
          //     citation_author_list = citation_author_list + ", " + this_author['given'] + " " + this_author['family']
          //   }
          // });
          // yearpub = ""
          // if (response.hasOwnProperty("published-print")) {
          //   yearpub = response["published-print"]["date-parts"][0][0]
          // } else {
          //   yearpub = response["published-online"]["date-parts"][0][0]
          // }
          // page = ""
          // if (response.hasOwnProperty("page")) {
          //   page = ", p" + response["page"]
          // }
          // citation_author_list += " " + yearpub + ". \"" + response["title"] + ".\" " + response["container-title"] + " " + response["volume"] + "(" + response["issue"] + ")" + page + ". " + response["publisher"] + ". doi:" + response["DOI"]

          // $("#edit-field-ordered-list-of-authors-0-value").val(author_list)

          // $("#edit-field-ercore-pb-full-citation-0-value").val(citation_author_list)

          // $.each(response.author, function (index, this_author) {
          //   author_list = author_list + this_author['given'] + " " + this_author['family'] + "\n"

          //   if (this_author['sequence'] == "first") {
          //     citation_author_list = citation_author_list + this_author['family'] + ", " + this_author['given']
          //   } else {
          //     citation_author_list = citation_author_list + ", " + this_author['given'] + " " + this_author['family']
          //   }
          // });
          $("#edit-field-ercore-pb-full-citation-0-value").val("EMPTY"); // TODO remove this
            author_list = "";
            citation_author_list = "";
            $.each(doiResponse.author, function (index, this_author) {
              console.log(doiResponse.author.length);
              if(index == doiResponse.author.length - 1 || doiResponse.author.length == 2){
                citation_author_list += " & ";
              } else if(index != doiResponse.author.length-1 && index != 0){
                citation_author_list += ", ";
              }
              citation_author_list = citation_author_list + this_author["family"] + ", " + this_author['given'].charAt(0) + ".";

            });
            yearpub = ""
            if (doiResponse.hasOwnProperty("published-print")) {
              yearpub = doiResponse["published-print"]["date-parts"][0][0]
            } else {
              yearpub = doiResponse["published-online"]["date-parts"][0][0]
            }
            citation_author_list = citation_author_list + " (" + yearpub + "). " + doiResponse["title"] + ". ";
            if(doiResponse.type == "article-journal" || doiResponse.type == "article-newspaper" || doiResponse.type == "article-magazine"){
              citation_author_list += doiResponse["container-title"] + ", " + doiResponse.volume + ", ";
            }
            if (doiResponse.hasOwnProperty("page")) {
              citation_author_list += doiResponse.page + ". ";
            }
            citation_author_list += "DOI: " + doiResponse["DOI"];
            $("#edit-field-ercore-pb-full-citation-0-value").val(citation_author_list);

          // citation right now is chicago
          function citation() {
            var citStr = "";
            $.each(response.author, function (index, value) {
              $.each(value, function (obj, val) {
                if (obj == "given") {
                  citStr += val + ", ";
                }
                if (obj == "family") {
                  citStr += val.charAt(0);
                  if (val.charAt(-1) == ".") {

                  }
                }
              });
            });
          }

          // TODO parse and set full citation
          // switch(response.type){
          //   case "article-journal" :
          //     citation
          //     break;
          //   case "book":
          //     break;
          //   case "paper-conference":
          //     break;
          //   case "article-magazine":
          //     break;
          //   case "report":
          //     break;
          //   case "article-newspaper":
          //     break;
          // }
          // console.log(response); // server response
          // console.log(response["container-title"]); // server response
          function issbn() {
            count = 0;
            if (response.hasOwnProperty("ISSN")) {
              count += 1;
            }
            if (response.hasOwnProperty("ISBN")) {
              count += 2;
            }
            return count;
          }
          switch (issbn()) {
            case 0:
              break;
            case 1:
              $("#edit-field-ercore-pb-issn-0-value").val(response.ISSN);
              break;
            case 2:
              $("#edit-field-ercore-pb-issn-0-value").val(response.ISBN);
              break;
            case 3:
              $("#edit-field-ercore-pb-issn-0-value").val(response.ISSN + "/" + response.ISBN);
          }

          pubdate = new Date(response["created"]["date-time"])
          var pubdate_day = ('0' + pubdate.getDate()).slice(-2);
          var pubdate_month = ('0' + (pubdate.getMonth() + 1)).slice(-2); //Months are zero based
          var pubdate_year = pubdate.getFullYear();
          pub_str = pubdate_year + "-" + pubdate_month + "-" + pubdate_day;
          $("#edit-field-ercore-pb-date-0-value-date").val(pub_str);
          $("#edit-field-ercore-pb-link-0-uri").val(response["URL"])

          // function setPubDate(str) {
          //   count = 0;
          //   date = "";
          //   if (response[str]["date-parts"]["0"].length == 3) {
          //     while (count < response[str]["date-parts"]["0"].length) {

          //       date += response[str]["date-parts"]["0"][count];
          //       if (count != 2) {
          //         date += "-";
          //       }
          //       count++;
          //     }
          //     $("#edit-field-ercore-pb-date-0-value-date").val(date);
          //   }

          // }

          function hasDates() {
            $("#edit-field-ercore-pb-status").val("0");
            $("#edit-field-ercore-pb-date-wrapper").show();
            $("#edit-field-ercore-pb-submit-date-wrapper").show();
            $("#edit-field-ercore-nsf-wrapper").show();
            if (response.hasOwnProperty("published-print") && response.hasOwnProperty("published-online")) {
              return "both";
            }
            else if (response.hasOwnProperty("published-print")) {
              return "print";
            }
            else if (response.hasOwnProperty("published-online")) {
              return "online"
            }
            else {
              return null;
            }
          }

          var pubType = ["published-online", "published-print"];
          pubMap = {
            "published-online": {
              "obj": null,
              "str": ""
            },
            "published-print": {
              "obj": null,
              "str": ""
            }
          }

          // switch (hasDates()) {

          //   case "both":
          //     $.each(pubType, function (index, val) {
          //       dateStr = "";
          //       pub = response[val]["date-parts"][0];
          //       $.each(pub, function (index, value) {
          //         if (value < 10) {
          //           dateStr += "0";
          //         }
          //         dateStr += (value + '-');
          //       });
          //       dateStr = dateStr.slice(0, -1);
          //       pubMap[val]["obj"] = new Date(dateStr);
          //       pubMap[val]["str"] = dateStr;
          //     });

          //     if (pubMap['published-online']["obj"].getTime() < pubMap['published-print']["obj"].getTime()) {
          //       $("#edit-field-ercore-pb-date-0-value-date").val(pubMap['published-online']["str"]);
          //     }
          //     else {
          //       $("#edit-field-ercore-pb-date-0-value-date").val(pubMap['published-print']["str"]);
          //     }
          //     break;
          //   case "print":
          //     setPubDate("published-print");
          //     break;
          //   case "online":
          //     setPubDate("published-online");
          //     break;
          //   case "null":
          //     break;

          // }
        }
      });

    }, false);
    // add change listenter to citation format list
    var citeFormatList = document.getElementById('edit-field-citation-format');
    citeFormatList.addEventListener('change', function(){
      console.log($('#edit-field-citation-format').val());
      // var selectedVal = $(this).find(':selected').val(); //alternate way of getting same result as selection = $('#edit-field-citation-format').val();
      // var selectedText = $(this).find(':selected').text();
      selection = $('#edit-field-citation-format').val();
      console.log(selection)
      var citation = "";
      if(doiResponse != null){
        switch (selection){
          case '_none':
            $("#edit-field-ercore-pb-full-citation-0-value").val("");
            break;
          case 'APA':
            $("#edit-field-ercore-pb-full-citation-0-value").val("EMPTY"); // TODO remove this
            author_list = "";
            citation_author_list = "";
            $.each(doiResponse.author, function (index, this_author) {
              console.log(doiResponse.author.length);
              if(index == doiResponse.author.length - 1 || doiResponse.author.length == 2){
                citation_author_list += " & ";
              } else if(index != doiResponse.author.length-1 && index != 0){
                citation_author_list += ", ";
              }
              citation_author_list = citation_author_list + this_author["family"] + ", " + this_author['given'].charAt(0) + ".";

            });
            yearpub = ""
            if (doiResponse.hasOwnProperty("published-print")) {
              yearpub = doiResponse["published-print"]["date-parts"][0][0]
            } else {
              yearpub = doiResponse["published-online"]["date-parts"][0][0]
            }
            citation_author_list = citation_author_list + " (" + yearpub + "). " + doiResponse["title"] + ". ";
            if(doiResponse.type == "article-journal" || doiResponse.type == "article-newspaper" || doiResponse.type == "article-magazine"){
              citation_author_list += doiResponse["container-title"] + ", " + doiResponse.volume + ", ";
            }
            if (doiResponse.hasOwnProperty("page")) {
              citation_author_list += doiResponse.page + ". ";
            }
            citation_author_list += "DOI: " + doiResponse["DOI"];
            $("#edit-field-ercore-pb-full-citation-0-value").val(citation_author_list);
            break;
          case 'Chicago':
            //Authors List
            author_list = ""
            citation_author_list = ""
            $.each(doiResponse.author, function (index, this_author) { //TODO
              author_list = author_list + this_author['given'] + " " + this_author['family'] + "\n"

              if (this_author['sequence'] == "first") {
                citation_author_list = citation_author_list + this_author['family'] + ", " + this_author['given']
              } else {
                citation_author_list = citation_author_list + ", " + this_author['given'] + " " + this_author['family']
              }
            });
            yearpub = ""
            if (doiResponse.hasOwnProperty("published-print")) {
              yearpub = doiResponse["published-print"]["date-parts"][0][0]
            } else {
              yearpub = doiResponse["published-online"]["date-parts"][0][0]
            }
            page = ""
            if (doiResponse.hasOwnProperty("page")) {
              page = ", p" + doiResponse["page"]
            }
            citation_author_list += " " + yearpub + ". \"" + doiResponse["title"] + ".\" " + doiResponse["container-title"] + " " + doiResponse["volume"] + "(" + doiResponse["issue"] + ")" + page + ". " + doiResponse["publisher"] + ". doi:" + doiResponse["DOI"]

            $("#edit-field-ercore-pb-full-citation-0-value").val(citation_author_list);
            break;
        }
          $.each(doiResponse.author, function (index, this_author) {
            console.log(this_author);
          });
      }
      // $("#edit-field-ercore-pb-full-citation-0-value").val(selection);
      // console.log(test);
      // console.log(selectedVal);
      // console.log(selectedText);
      // if selected
    });
  }(jQuery))
};